/*-----------------------------------------------------------------------------------------*/
//					
//								Repertoire 2002	v1.01
//																					
// File:  Repertoire2002.cpp	
//																											
// Contains: main part of the software ....																		
//																										
// Written by:	DEL NERO Jean Francois																					
//				Guitton Rmy
//																					
// Copyright: Copyright 2002-2003 ECE
//   		  www.powerofasm.fr.st
//																									
// Change History (most recent first):																				
//    29/1/2003 : v1.0a->v1.0 
//				correction du bug fichier (effacement)
//				ajout du telephone portable
//				tabulation active (IsDialogMessage)	
//				changement dispositions graphiques...																							
//  			ajout d'un header au fichier...																								
//    30/1/2003 : v1.0->v1.01
//				ajout de la verif de l'absence d'un autre process
//				(findwindow...)
/*-----------------------------------------------------------------------------------------*/



// includes pour les declaration de type et fonctions windows
#include <windows.h>
#include <commctrl.h>

// includes pour les fonctions standard et de temps
#include <stdio.h>
#include <time.h>

// include pour la declaration des identificateurs
// des elements graphiques (gener par visual)

#include <mmsystem.h>
#include "..\includes\mod32.h"
#include <math.h>



#include "..\resource.h"

// includes des differentes parties du programme.
#include "..\includes\Repertoire2002Liste.h"
#include "..\includes\Repertoire2002.h"
#include "..\includes\Repertoire2002I.h"

#include "..\includes\themod.h"
#include "..\includes\logoece.h"


HWND Dialog;


////////////////////////////////////////////////////////////////////////// 
//
//  Point d'entre du programme
//  
//
//////////////////////////////////////////////////////////////////////////

void APIENTRY EntryPoint()
{
	MSG msg;
	LPSTR  CmdLine;
	HWND hWnd;

	// Recuperation de la ligne de commande (pour gerer dans une prochaine version..)
	CmdLine=GetCommandLine();
    
	// Verification que l'application n'est pas deja lance..
	if ((hWnd = FindWindow(NULL, NOMFENETRE)) == NULL)
	{
		// Appel de la fonction d'initialisation graphique
		WinMain(GetModuleHandle(NULL),NULL,CmdLine,SW_SHOWDEFAULT);

		//Boucle de recuperation des messages evenement
		//et de leurs envois vers la fonction de traitement
		while(GetMessage(&msg,NULL,0,0))
		{     
			if(!IsDialogMessage(Dialog,&msg))
			{
				TranslateMessage(&msg);
				// transmission de l'evenement a la fonction WndProc
				DispatchMessage(&msg);
			}
		}
	
		//Fin du programme
	
		// Suppression de l'icone de la barre des taches
		SupprimeIcone(GetActiveWindow(), 0);
    
		// Sauvegarde de la liste
		if(!SauvegardeListe(GetListe(),FICHIERFICHES))
			MessageBox(GetActiveWindow(),"Can't save the data file !!!","Write Error !",MB_OK|MB_ICONHAND);
	}
	else
	{	//envois du message a l'autre process
		SendMessage(hWnd, WM_USER, 0, WM_LBUTTONDOWN);
	}
	// Fin
	ExitProcess(0);
}


////////////////////////////////////////////////////////////////////////// 
//
//  Procedure d'initialisation de l'application et des fenetres...
//
//////////////////////////////////////////////////////////////////////////


int APIENTRY WinMain(HINSTANCE hInst     ,
                     HINSTANCE hPrevInst ,
                     LPSTR     CmdLine   ,
                     int       CmdShow   )
{
	HICON   hIcon;
	HWND hWnd;
	WNDCLASSEX wc;
	HWND hDlg_PagePrincipale;
	int TailleX,TailleY;
	
	// Chargement icone

    hIcon=LoadIcon(hInst,(const char *)500);
  
	//Creation de la 'classe' fenetre utilis par l'application...

	wc.cbSize=sizeof(WNDCLASSEX);
	wc.style=NULL;
    //pointeur de la fonction de traitement des evenement
	wc.lpfnWndProc=WndProc;
    wc.cbClsExtra=NULL; 
    wc.hInstance=hInst;
    wc.hbrBackground=(HBRUSH)COLOR_BTNFACE;
    wc.lpszMenuName=NULL;
    wc.lpszClassName="Rep2002_Class";
    wc.hIcon=hIcon;	
	wc.hCursor=LoadCursor(NULL,IDC_ARROW);
	//icone de l'application
	wc.hIconSm=hIcon;
	wc.cbWndExtra=NULL;

	RegisterClassEx(&wc); 
 

 //Calcul de la taille fenetre (a verifier)

	TailleX=458;
	TailleY=254+GetSystemMetrics(SM_CYCAPTION)+GetSystemMetrics(SM_CYMENU)+GetSystemMetrics(SM_CYBORDER)-3;


 // Cration de la fenetre principale

	hWnd=CreateWindowEx(WS_EX_LEFT,"Rep2002_Class",NOMFENETRE,WS_MINIMIZEBOX|WS_OVERLAPPED|WS_SYSMENU,16,16,TailleX,TailleY,NULL,NULL,hInst,NULL);
 
 // chargement et application du Menu

	SetMenu(hWnd,LoadMenu(hInst,(const char *)600));
 
 // Affichage de la fenetre principale

	ShowWindow(hWnd,SW_SHOWNORMAL);

 // Initialisation des boites de dialogues

	hDlg_PagePrincipale=CreateDialog(hInst,(const char*)ID_DIALOG_PAGE_PRINCIPALE,hWnd,&DialogProc);
	 
 // Affichage de la Boite principale

	ShowWindow(hDlg_PagePrincipale,SW_SHOWNORMAL);

 // Ajout de l'icone dans la barre des taches

	AjouteModifieIcone(hWnd, 0, LoadIcon(hInst, MAKEINTRESOURCE(500)),true);
 
 // Prparation des listes d'affichage 

	InitList(hDlg_PagePrincipale,(const char *)ID_LIST_1);

 // Initialisation d'un timer pour l'autosauvegarde et la verif periodique des fetes..
	
	SetTimer(hWnd,0,20*1000,&TimerProc1);
	SetTimer(hWnd,1,1000,&TimerProc1);
	

 // Chargement de la liste en mmoire
	
	SetListe(ChargerListe(GetListe(),FICHIERFICHES));

 // On affiche la liste dans la liste de la page principale (liste vue)
	RafraichirListe(GetListe(),GetDlgItem(hDlg_PagePrincipale, ID_LIST_1));
	

 return 0;
}


////////////////////////////////////////////////////////////////////////// 
//
//  Fonction de gestion des venements de la fenetre Mere
//  (Appelle par windows lorsqu'un evenement arrive  la fenetre.)
//
//////////////////////////////////////////////////////////////////////////

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;

	switch (message) // switch selon le message
	{
		case WM_COMMAND:	//Action sur un menu

			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			
			switch (wmId)
			{
				case ID_MENU_EXIT:   // Fin (venant du menu)
				   SupprimeIcone(hWnd, 0);
				   DestroyWindow(hWnd);
				   break;
				
				case ID_POPUP_ABOUT:
				case ID_ABOUT:
				   CreateDialog(GetModuleHandle(NULL),(const char*)ID_DIALOG_ABOUT,GetActiveWindow(),&DialogAbout);
				   break;
				
				case ID_POPUP_QUIT:   // Fin (venant du popup de la barre des taches)
				   SupprimeIcone(hWnd, 0);
				   PostQuitMessage(0);
				   break;
								
				default:// traitement par defaut de l'evenement (gerer par windows)
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
				
		case WM_DESTROY:
			PostQuitMessage(0);//fin
			break;
		
		case WM_USER: //Message venant de l'icone de la barre des taches
			
			if (lParam == WM_LBUTTONDOWN) //traitement bouton gauche de la souris
			{	
				if(GetFocus()==hWnd) // fenetre principale en premier plan ?
				{
					ShowWindow(hWnd,SW_HIDE); // si oui on la cache
				}
				else 
				{
					ShowWindow(hWnd,SW_SHOWNORMAL); // si non on la montre
					SetFocus(hWnd);
				}

			}
			
			if (lParam == WM_RBUTTONDOWN) //traitement bouton droit de la souris
			{	
				ListPopup(hWnd,NULL);	//Affichage du popup ...
			}		
			break;

		
		case WM_CLOSE: //message de fermeture
			ShowWindow(hWnd,SW_HIDE); // *-> on cache la fenetre
		break;

		default: // traitement par defaut de l'evenement (gerer par windows)
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}
 
////////////////////////////////////////////////////////////////////////// 
//
//  Fonction de gestion des venements des boite de dialogues
//  
//////////////////////////////////////////////////////////////////////////

BOOL CALLBACK DialogProc(
    HWND  hwndDlg,	// handle of dialog box
    UINT  message,	// message
    WPARAM  wParam,	// first message parameter
    LPARAM  lParam 	// second message parameter
   )
{
	
	HWND hListt;
	
	
	int wmId, wmEvent;
	
	int i;

	char temp0[512];
	char temp1[512];
	char t1[]="";
	typefiche fiche;
	selemliste * fiche2;

	NM_LISTVIEW *pNm = (NM_LISTVIEW *)lParam; 

	
	switch (message) 
	{


	

	case WM_NOTIFY:	
		if (wParam == ID_LIST_1 || wParam == ID_LIST_2) // message concernant la liste (vue)
			{
				NM_LISTVIEW* pnmv = (NM_LISTVIEW*)lParam;
				
				switch (pnmv->hdr.code) // code du message de la liste
				{
					case LVN_KEYDOWN: //Clavier
						switch (((LV_KEYDOWN *)lParam)->wVKey)
						{
							case VK_DELETE:	// Touche Suppr					
								//on simul le bouton supprimer
								SendMessage(hwndDlg,WM_COMMAND,ID_BOUTON_SUPPRIMER_P,BN_CLICKED);  					
							break;
							case VK_INSERT: // Touche Inser
								//on simul le bouton inserer
								SendMessage(hwndDlg,WM_COMMAND,ID_BOUTON_AJOUTER,BN_CLICKED);  
							break;	
						}
						break;

					case LVN_COLUMNCLICK: 
						// demande de trie de la liste (vue)
						ListView_SortItems(pNm->hdr.hwndFrom,ListViewCompareProc,(LPARAM)(pNm->iSubItem)); 
					break;

					case NM_RCLICK: //bouton droit souris 
						// affichage du popup
						ListPopup(hwndDlg,GetDlgItem(hwndDlg, wParam));
						break;

					case NM_DBLCLK: // double clique -> Affichage du fiche
						//recup du nom de la liste 
						hListt=GetDlgItem(hwndDlg, wParam);
						if(ListView_GetSelectedCount(hListt)>0)
						{
							// Recuperation de 'l'id' fiche (nom+prenom) dans la liste vue
							i = ListView_GetNextItem(hListt, -1, LVNI_ALL | LVNI_SELECTED);
							ListView_GetItemText(hListt, i, 0, (char*)&temp1,512);
							// Recherche de la fiche 'reel' correspondante
							fiche2=RechercherFiche(GetListe(),temp1);
							
							// Creation de la boite de dialogue
							Dialog=CreateDialog(GetModuleHandle(NULL),(const char*)ID_DIALOG_FICHE,GetActiveWindow(),&DialogFicheProc);
							// initialisation des diffrents champs :
							
							// Champ Nom Prenom
							sprintf((char*)&temp1,"%s  %s",(char*)&fiche2->unefiche->nom,(char*)&fiche2->unefiche->prenom);
							SetDlgItemText(Dialog,ID_TEXT_NOM,(char*)&temp1);
							
							// Champ Date de naissance
							if(fiche2->unefiche->datedenaissance.jour!=0 && fiche2->unefiche->datedenaissance.mois!=0 && fiche2->unefiche->datedenaissance.annee!=0)
							{
								sprintf((char*)&temp1,"%d/%d/%d ",fiche2->unefiche->datedenaissance.jour,fiche2->unefiche->datedenaissance.mois,fiche2->unefiche->datedenaissance.annee);
								SetDlgItemText(Dialog,ID_TEXT_DATEN,(char*)&temp1);
							}

							// Champ adresse
							sprintf((char*)&temp1,"%s  %s ",(char*)&fiche2->unefiche->adresse.numero,(char*)&fiche2->unefiche->adresse.rue);
							SetDlgItemText(Dialog,ID_TEXT_ADRESSE1,(char*)&temp1);
							sprintf((char*)&temp1,"%s %s",(char*)&fiche2->unefiche->adresse.codepostal,(char*)&fiche2->unefiche->adresse.ville);
							SetDlgItemText(Dialog,ID_TEXT_ADRESSE2,(char*)&temp1);
							sprintf((char*)&temp1,"%s ",(char*)&fiche2->unefiche->adresse.pays);
							SetDlgItemText(Dialog,ID_TEXT_ADRESSE3,(char*)&temp1);
							
							// Champ telephone
							SetDlgItemText(Dialog,ID_TEXT_TEL,(char*)&fiche2->unefiche->numtel);
							SetDlgItemText(Dialog,ID_TEXT_TELP,(char*)&fiche2->unefiche->numtelp);

							// Champ Email
							SetDlgItemText(Dialog,ID_TEXT_EMAIL,(char*)&fiche2->unefiche->email);
							
							// Affichage
							ShowWindow(Dialog,SW_SHOWNORMAL);

						}
					break;
					default:;
				}
			}
		break;

	case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 

		//	Evenement Popup :
		switch (wmId)
			{
				case ID_POPUP_AJOUTER:   
				   SendMessage(hwndDlg,WM_COMMAND,ID_BOUTON_AJOUTER,BN_CLICKED); 
				   break;
				case ID_POPUP_SUPPRIMER_P://(page principale)   
				   SendMessage(hwndDlg,WM_COMMAND,ID_BOUTON_SUPPRIMER_P,BN_CLICKED); 
				   break;
				case ID_POPUP_SUPPRIMER_R://(page rechercher)      
				   SendMessage(hwndDlg,WM_COMMAND,ID_BOUTON_SUPPRIMER_R,BN_CLICKED); 
				   break;
				case ID_POPUP_RECHERCHER:   
				   SendMessage(hwndDlg,WM_COMMAND,ID_BOUTON_RECHERCHER,BN_CLICKED); 
				   break;
				case ID_POPUP_MODIFIER_P://(page principale)   
				   SendMessage(hwndDlg,WM_COMMAND,ID_BOUTON_MODIFIER_P,BN_CLICKED); 
				   break;
				case ID_POPUP_MODIFIER_R://(page rechercher)   
				   SendMessage(hwndDlg,WM_COMMAND,ID_BOUTON_MODIFIER_R,BN_CLICKED); 
				   break;
				default:;
			}

///////////////////////////	
		
		switch (wmEvent) 
		{

		case EN_CHANGE: //-> appell a chaque modification d'une boite edit
			
			if(wmId==ID_TEXT_NOM_R || wmId==ID_TEXT_PRENOM_R) // Modification des boite noms ou prenoms
			{
				GetDlgItemText(hwndDlg,ID_TEXT_NOM_R,(char*)&fiche.nom,512);
				GetDlgItemText(hwndDlg,ID_TEXT_PRENOM_R,(char*)&fiche.prenom,512);
				//Filtrage et affichage dans la liste (vue) de recherche
				RechercherFicheCritere(GetListe(),fiche,GetDlgItem(hwndDlg, ID_LIST_2));
				ListView_SortItems(GetDlgItem(hwndDlg, ID_LIST_2),ListViewCompareProc,0);
			}
		break;

///////////////////////////					
		case BN_CLICKED: //-> un bouton a t click
				
				switch (wmId) 
				{
///////////////////////////					
					case ID_BOUTON_EXIT: //Bouton quitter
						if(MessageBox(hwndDlg,"Voulez vraiment quitter le programme ?","Quitter ?",MB_ICONQUESTION|MB_YESNO	)==IDYES)
						{
							PostQuitMessage(0);
						}
					break;
////////////////////////////
					case ID_BOUTON_RECHERCHER: //Bouton rechercher

						//Initialisation de la boite rechercher
						Dialog=ChangeDialog(hwndDlg,(const char*)ID_DIALOG_RECHERCHER);
						InitList(Dialog,(const char *)ID_LIST_2);
						SetDlgItemText(Dialog,ID_TEXT_NOM, (char*)t1);
						SetDlgItemText(Dialog,ID_TEXT_PRENOM,(char*)t1);
						GetDlgItemText(Dialog,ID_TEXT_NOM,(char*)&fiche.nom,512);
						GetDlgItemText(Dialog,ID_TEXT_PRENOM,(char*)&fiche.prenom,512);
						// Affichage des elements dans la liste (vue)
						RechercherFicheCritere(GetListe(),fiche,GetDlgItem(Dialog, ID_LIST_2));
						ListView_SortItems(GetDlgItem(Dialog, ID_LIST_2),ListViewCompareProc,0);
					break;
////////////////////////////
					case ID_BOUTON_AJOUTER: //Bouton ajouter
						
						//Initialisation de la boite ajouter
					    Dialog=ChangeDialog(hwndDlg,(const char*)ID_DIALOG_AJOUTER);
												
						SetDlgItemText(Dialog,ID_TEXT_NOM,(char*)t1);
						SetDlgItemText(Dialog,ID_TEXT_PRENOM,(char*)t1);
						SetDlgItemText(Dialog,ID_TEXT_ADRNOMRUE,(char*)t1);
						SetDlgItemText(Dialog,ID_TEXT_TEL,(char*)t1);
						SetDlgItemText(Dialog,ID_TEXT_ADRVILLE,(char*)t1);
						SetDlgItemText(Dialog,ID_TEXT_ADRCODEP,(char*)t1);
						SetDlgItemText(Dialog,ID_TEXT_ADRNUM,(char*)t1);				
					break;
////////////////////////////					
					case ID_BOUTON_RETOUR:
						//Initialisation de la boite page principale
						Dialog=ChangeDialog(hwndDlg,(const char*)ID_DIALOG_PAGE_PRINCIPALE);
						InitList(Dialog,(const char *)ID_LIST_1);
						RafraichirListe(GetListe(),GetDlgItem(Dialog, ID_LIST_1));
					break;

////////////////////////////
					case ID_BOUTON_SUPPRIMER_R:
					case ID_BOUTON_SUPPRIMER_P:
						
						if(wmId==ID_BOUTON_SUPPRIMER_P)
							hListt=GetDlgItem(hwndDlg, ID_LIST_1);
						else 
							hListt=GetDlgItem(hwndDlg, ID_LIST_2);

						// Un element est selectionn ?
						if(ListView_GetSelectedCount(hListt)>0)
						{
							//recuperation du nom de la liste 
							i  = ListView_GetNextItem(hListt, -1, LVNI_ALL | LVNI_SELECTED);
							ListView_GetItemText(hListt, i, 0, (char*)&temp1,512);
					
							strcpy((char*)temp0,"Voulez-vous rellement supprimer la fiche ");
							strcat((char*)temp0,(char*)temp1);
							strcat((char*)temp0," ?");
							// Demande de confirmation
							if(MessageBox(hwndDlg,(char*)&temp0,"Suppression ?",MB_ICONQUESTION|MB_YESNO)==IDYES)
							{
								// Suppression de la fiche
								SetListe(SupprimerFiche(GetListe(),(char*)temp1));
									
								// Mise a jour de la vue (page principale)
								if(wmId==ID_BOUTON_SUPPRIMER_P)
								{
									RafraichirListe(GetListe(),GetDlgItem(hwndDlg, ID_LIST_1));
								}
								// Mise a jour de la vue (page rechercher)
								else 
								{
									GetDlgItemText(hwndDlg,ID_TEXT_NOM_R,(char*)&fiche.nom,512);
									GetDlgItemText(hwndDlg,ID_TEXT_PRENOM_R,(char*)&fiche.prenom,512);
									RechercherFicheCritere(GetListe(),fiche,GetDlgItem(hwndDlg, ID_LIST_2));
									ListView_SortItems(GetDlgItem(hwndDlg, ID_LIST_2),ListViewCompareProc,0);
								}
							}
						
						}
					break;

////////////////////////////
					case ID_BOUTON_MODIFIER_R:
					case ID_BOUTON_MODIFIER_P:
						if(wmId==ID_BOUTON_MODIFIER_P)
							hListt=GetDlgItem(hwndDlg, ID_LIST_1);
						else 
							hListt=GetDlgItem(hwndDlg, ID_LIST_2);
						
						// Un element est selectionn ?
						if(ListView_GetSelectedCount(hListt)>0)
						{
							//Recuperation de l'element selectionn
							i  = ListView_GetNextItem(hListt, -1, LVNI_ALL | LVNI_SELECTED);
							ListView_GetItemText(hListt, i, 0, (char*)&temp1,512);
						
							//page modifier...
							Dialog=ChangeDialog(hwndDlg,(const char*)ID_DIALOG_MODIFIER);
							
							// 'Sauvegarde' de l'id fiche...
							SetDlgItemText(Dialog,ID_TEXT_HIDDEN, (char*)&temp1);
			
							//Recherche de la fiche
							fiche2=RechercherFiche(GetListe(),temp1);
							
							//initialisation des diffrents champs
							SetDlgItemText(Dialog,ID_TEXT_NOM, (char*)fiche2->unefiche->nom);
							SetDlgItemText(Dialog,ID_TEXT_PRENOM,(char*)fiche2->unefiche->prenom);
							SetDlgItemText(Dialog,ID_TEXT_TEL,(char*)&fiche2->unefiche->numtel);
							SetDlgItemText(Dialog,ID_TEXT_TELP,(char*)&fiche2->unefiche->numtelp);
							SetDlgItemText(Dialog,ID_TEXT_EMAIL,(char*)&fiche2->unefiche->email);
							if(fiche2->unefiche->datedenaissance.jour!=0 && fiche2->unefiche->datedenaissance.mois!=0 &&fiche2->unefiche->datedenaissance.annee!=0)
							{
								SetDlgItemInt(Dialog,ID_TEXT_DATEN_JOUR,fiche2->unefiche->datedenaissance.jour,false);
								SetDlgItemInt(Dialog,ID_TEXT_DATEN_MOIS2,fiche2->unefiche->datedenaissance.mois,false);
								SetDlgItemInt(Dialog,ID_TEXT_DATEN_ANNEE,fiche2->unefiche->datedenaissance.annee,false);
							}
							SetDlgItemText(Dialog,ID_TEXT_ADRNUM,(char*)fiche2->unefiche->adresse.numero);
							SetDlgItemText(Dialog,ID_TEXT_ADRNOMRUE,(char*)fiche2->unefiche->adresse.rue);
							SetDlgItemText(Dialog,ID_TEXT_ADRVILLE,(char*)fiche2->unefiche->adresse.ville);
							SetDlgItemText(Dialog,ID_TEXT_ADRCODEP,(char*)fiche2->unefiche->adresse.codepostal);
							SetDlgItemText(Dialog,ID_TEXT_ADRPAYS,(char*)fiche2->unefiche->adresse.pays);	

						}
					break;

////////////////////////////			

					case ID_BOUTON_VALIDER_AJOUT:
						
						//recuperation des champs et cration du nouvel lment dans la liste 

						GetDlgItemText(hwndDlg,ID_TEXT_NOM,(char*)&fiche.nom,sizeof(fiche.nom));
						GetDlgItemText(hwndDlg,ID_TEXT_PRENOM,(char*)&fiche.prenom,sizeof(fiche.prenom));
						GetDlgItemText(hwndDlg,ID_TEXT_TEL,(char*)&fiche.numtel,sizeof(fiche.numtel));
						GetDlgItemText(hwndDlg,ID_TEXT_TELP,(char*)&fiche.numtelp,sizeof(fiche.numtelp));
						GetDlgItemText(hwndDlg,ID_TEXT_EMAIL,(char*)&fiche.email,sizeof(fiche.email));
						
						// traitement de la date de naissance
						fiche.datedenaissance.jour=GetDlgItemInt(hwndDlg,ID_TEXT_DATEN_JOUR,(int*)&i,false);
						fiche.datedenaissance.mois=GetDlgItemInt(hwndDlg,ID_TEXT_DATEN_MOIS,(int*)&i,false);
						fiche.datedenaissance.annee=GetDlgItemInt(hwndDlg,ID_TEXT_DATEN_ANNEE,(int*)&i,false);
						
						if(fiche.datedenaissance.jour<1 || fiche.datedenaissance.jour>31 ||fiche.datedenaissance.mois<1 ||fiche.datedenaissance.mois>12)
						{fiche.datedenaissance.jour=0; fiche.datedenaissance.mois=0;}
						if(fiche.datedenaissance.annee<=4 && fiche.datedenaissance.annee>=0)
						fiche.datedenaissance.annee=fiche.datedenaissance.annee+2000;
						if(fiche.datedenaissance.annee>4 && fiche.datedenaissance.annee<99)
						fiche.datedenaissance.annee=fiche.datedenaissance.annee+1900;
						if(fiche.datedenaissance.annee>2010)fiche.datedenaissance.annee=0;
						if(fiche.datedenaissance.annee>99 && fiche.datedenaissance.annee<1900)fiche.datedenaissance.annee=0;

						GetDlgItemText(hwndDlg,ID_TEXT_ADRNUM,(char*)&fiche.adresse.numero,sizeof(fiche.adresse.numero));				
						GetDlgItemText(hwndDlg,ID_TEXT_ADRNOMRUE,(char*)&fiche.adresse.rue,sizeof(fiche.adresse.rue));				
						GetDlgItemText(hwndDlg,ID_TEXT_ADRVILLE,(char*)&fiche.adresse.ville,sizeof(fiche.adresse.ville));				
						GetDlgItemText(hwndDlg,ID_TEXT_ADRCODEP,(char*)&fiche.adresse.codepostal,sizeof(fiche.adresse.codepostal));
						GetDlgItemText(hwndDlg,ID_TEXT_ADRPAYS,(char*)&fiche.adresse.pays,sizeof(fiche.adresse.pays));
						

						strcpy((char*)temp1,(char*)&fiche.nom);
						strcat((char*)temp1,ESPACENOMPRENOM);
						strcat((char*)temp1,(char*)&fiche.prenom);
						
						if(RechercherFiche(GetListe(),temp1)==NULL) //on verifie si la fiche n est pas presente !
						{	
							//Ajout du nouvel element 
							SetListe(AjouterElement(fiche,GetListe()));
							//et retour sur la page principale
							Dialog=ChangeDialog(hwndDlg,(const char*)ID_DIALOG_PAGE_PRINCIPALE);
							InitList(Dialog,(const char *)ID_LIST_1);
							
							RafraichirListe(GetListe(),GetDlgItem(Dialog, ID_LIST_1));
						}
						else // Fiche deja presente!!
						{
							sprintf((char*)&temp0,"La fiche %s existe deja !",&temp1);
							MessageBox(hwndDlg,(char*)&temp0,"Erreur !",MB_ICONEXCLAMATION|MB_OK);
						}
												
					break;
////////////////////////////					
					case ID_BOUTON_VALIDER_MODIF:
						//recuperation des champs et modifification de l'lment dans la liste 
									
						GetDlgItemText(hwndDlg,ID_TEXT_HIDDEN,(char*)&temp1,50);
					
						fiche2=RechercherFiche(GetListe(),temp1);

						GetDlgItemText(hwndDlg,ID_TEXT_NOM,(char*)&fiche.nom,50);
						GetDlgItemText(hwndDlg,ID_TEXT_PRENOM,(char*)&fiche.prenom,512);
						
						strcpy((char*)temp1,(char*)&fiche.nom);
						strcat((char*)temp1,ESPACENOMPRENOM);
						strcat((char*)temp1,(char*)&fiche.prenom);
						
						if(RechercherFiche(GetListe(),temp1)==NULL ||RechercherFiche(GetListe(),temp1)==fiche2) //on verifie si la fiche n est pas presente !
						{	
							GetDlgItemText(hwndDlg,ID_TEXT_NOM,(char*)&fiche2->unefiche->nom,sizeof(fiche2->unefiche->nom));
							GetDlgItemText(hwndDlg,ID_TEXT_PRENOM,(char*)&fiche2->unefiche->prenom,sizeof(fiche2->unefiche->prenom));
							GetDlgItemText(hwndDlg,ID_TEXT_TEL,(char*)&fiche2->unefiche->numtel,sizeof(fiche2->unefiche->numtel));
							GetDlgItemText(hwndDlg,ID_TEXT_TELP,(char*)&fiche2->unefiche->numtelp,sizeof(fiche2->unefiche->numtelp));
							GetDlgItemText(hwndDlg,ID_TEXT_EMAIL,(char*)&fiche2->unefiche->email,sizeof(fiche2->unefiche->email));
							fiche2->unefiche->datedenaissance.jour=GetDlgItemInt(hwndDlg,ID_TEXT_DATEN_JOUR,(int*)&i,false);
							fiche2->unefiche->datedenaissance.mois=GetDlgItemInt(hwndDlg,ID_TEXT_DATEN_MOIS2,(int*)&i,false);
							fiche2->unefiche->datedenaissance.annee=GetDlgItemInt(hwndDlg,ID_TEXT_DATEN_ANNEE,(int*)&i,false);
						
							if(fiche2->unefiche->datedenaissance.jour<1 || fiche2->unefiche->datedenaissance.jour>31 ||fiche2->unefiche->datedenaissance.mois<1 ||fiche2->unefiche->datedenaissance.mois>12)
							{fiche2->unefiche->datedenaissance.jour=0; fiche2->unefiche->datedenaissance.mois=0;}
							if(fiche2->unefiche->datedenaissance.annee<=4 && fiche2->unefiche->datedenaissance.annee>=0)
								fiche2->unefiche->datedenaissance.annee=fiche2->unefiche->datedenaissance.annee+2000;
							if(fiche2->unefiche->datedenaissance.annee>4 && fiche2->unefiche->datedenaissance.annee<99)
							fiche2->unefiche->datedenaissance.annee=fiche2->unefiche->datedenaissance.annee+1900;
							if(fiche2->unefiche->datedenaissance.annee>2010)fiche2->unefiche->datedenaissance.annee=0;
							if(fiche2->unefiche->datedenaissance.annee>99 && fiche2->unefiche->datedenaissance.annee<1900)fiche2->unefiche->datedenaissance.annee=0;

							GetDlgItemText(hwndDlg,ID_TEXT_ADRNUM,(char*)&fiche2->unefiche->adresse.numero,sizeof(fiche2->unefiche->adresse.numero));				
							GetDlgItemText(hwndDlg,ID_TEXT_ADRNOMRUE,(char*)&fiche2->unefiche->adresse.rue,sizeof(fiche2->unefiche->adresse.rue));				
							GetDlgItemText(hwndDlg,ID_TEXT_ADRVILLE,(char*)&fiche2->unefiche->adresse.ville,sizeof(fiche2->unefiche->adresse.ville));				
							GetDlgItemText(hwndDlg,ID_TEXT_ADRCODEP,(char*)&fiche2->unefiche->adresse.codepostal,sizeof(fiche2->unefiche->adresse.codepostal));
							GetDlgItemText(hwndDlg,ID_TEXT_ADRPAYS,(char*)&fiche2->unefiche->adresse.pays,sizeof(fiche2->unefiche->adresse.pays));
						
						Dialog=ChangeDialog(hwndDlg,(const char*)ID_DIALOG_PAGE_PRINCIPALE);
						InitList(Dialog,(const char *)ID_LIST_1);
						RafraichirListe(GetListe(),GetDlgItem(Dialog, ID_LIST_1));
						}
						else 
						{
							sprintf((char*)&temp0,"La fiche %s existe deja !",&temp1);
							MessageBox(hwndDlg,(char*)&temp0,"Erreur !",MB_ICONEXCLAMATION|MB_OK);
						}
	
					break;
					default:
					;
						
				}

			break;
			default:;
		}

	break;
	default:
	return false;
		
   
}

return true;
}

///////////////////////////////////////////About Demo//////////////////////////////////////
////////////////////////////////////////////////////////////////////////// 
//
//  Copie d'un sprite avec ondulation...
//  
//////////////////////////////////////////////////////////////////////////


void putsprite(unsigned int x,unsigned int y,unsigned char * buffer,unsigned int sx,unsigned int sy,unsigned char * sprite)
{
	
	static int t3=0;
	static float f3=0,f4,f5=0,f6=0;
	unsigned int start,i,j,t2,adr;
	unsigned char t,ty;
	static unsigned char m=0;
	t2=0;
	start=y*180+x;
	j=0;
	t3++;
	
	f3=f3+(float)0.5;
	f4=f3;
	f5=f5+(float)0.01;
	f6=f6+(float)0.02;

	if(t3>50*30){m=0;t3=0; }
	if(t3>50*20)  m=1;
	else if(t3>50*10)  m=2;

	if(180<=(111+x)) t2=(111+x)-180;

	for(j=0;j<sy;j++)
	{
		f4=f4+((float)sin(f5)/(float)2);
		ty=(unsigned char)((float)cos(f4)*(float)4+(float)4);
		if(180<=(111+x+ty)) t2=(111+x+ty)-180;
		else t2=0;
		for(i=0;i<(sx-t2);i++) 
		{
			adr=(j*180+i+start+ty);
			t=sprite[j*sx+i];
			if(adr<(180*86) && ((m==1 && t==255)|(m==2 && t!=255)|(m==0)))buffer[adr]=sprite[j*sx+i];
		}
	}
}

////////////////////////////////////////////////////////////////////////// 
//
//  Gestion Boite de dialogue apropos (Timer 50hz + Wave +msgs...)
//  
//////////////////////////////////////////////////////////////////////////
BOOL CALLBACK DialogAbout(
    HWND  hwndDlg,	// handle of dialog box
    UINT  message,	// message
    WPARAM  wParam,	// first message parameter
    LPARAM  lParam 	// second message parameter
   )
{
static char nbinstance=0;
static HWAVEOUT shwd;
static WAVEFORMATEX pwfx;
static WAVEHDR pwhOut1;
static WAVEHDR pwhOut2;
static char buffer2[1024*16];
static char buffer1[1024*16];
static float f1=0,f2=0;
int i,t;
static RECT myRect;
static HDC hdc;	
static unsigned char buffer[180*86];
static BITMAPINFO * bmapinfo;
static int fr;

	int wmId;//, wmEvent;

	
	wmId    = LOWORD(wParam);
	switch (message) 
	{
		case	MM_WOM_OPEN:
		break;
	
		case	MM_WOM_CLOSE:
		break;
	
		case	MM_WOM_DONE:
			GiveMeSamples(((struct wavehdr_tag *)lParam)->lpData,sizeof(buffer2));
			waveOutWrite(shwd,(struct wavehdr_tag *)lParam,sizeof(pwhOut2));
		break;

		case WM_COMMAND:
			switch (wmId)
			{
				case ID_OK:
					KillTimer(hwndDlg,33);
					waveOutReset(shwd);

					waveOutBreakLoop(shwd);
					waveOutBreakLoop(shwd);
  
					waveOutUnprepareHeader(shwd,&pwhOut1,sizeof WAVEHDR);
					waveOutUnprepareHeader(shwd,&pwhOut2,sizeof WAVEHDR);
					CLOSEMODSYS();

					waveOutClose(shwd);
					nbinstance=0;

					DestroyWindow(hwndDlg);
				default:;
			}
		break;

		
		case WM_INITDIALOG:
			if(nbinstance!=0)
			{
				DestroyWindow(hwndDlg);
			}
			else
			{
				fr=1;
				nbinstance=1;
				bmapinfo = (BITMAPINFO *) malloc(((sizeof(BITMAPINFO) + sizeof(RGBQUAD) * 255)));
				bmapinfo->bmiHeader.biSize=sizeof(bmapinfo->bmiHeader);
				bmapinfo->bmiHeader.biWidth=180;
				bmapinfo->bmiHeader.biHeight=-86;
				bmapinfo->bmiHeader.biPlanes=1;
				bmapinfo->bmiHeader.biBitCount=8;
				bmapinfo->bmiHeader.biCompression=BI_RGB;
				bmapinfo->bmiHeader.biSizeImage=0;
				bmapinfo->bmiHeader.biXPelsPerMeter=0;
				bmapinfo->bmiHeader.biYPelsPerMeter=0;
				bmapinfo->bmiHeader.biClrUsed=0;
				bmapinfo->bmiHeader.biClrImportant=0;

				for(i=0;i<256;i++)
				{	
					bmapinfo->bmiColors[i].rgbBlue=i;
					bmapinfo->bmiColors[i].rgbGreen=i;
					bmapinfo->bmiColors[i].rgbRed=i;
					bmapinfo->bmiColors[i].rgbReserved=0;
				}


				for(i=0;i<16;i++)
				{	
					bmapinfo->bmiColors[i].rgbBlue=pallogoece[3*i+2];
					bmapinfo->bmiColors[i].rgbGreen=pallogoece[3*i+1];
					bmapinfo->bmiColors[i].rgbRed=pallogoece[3*i];
					bmapinfo->bmiColors[i].rgbReserved=0;
				}

				if(waveOutGetNumDevs()!=0)
				{
					InitModule(NULL,buffer1,sizeof(buffer1),(char*)&themod);
					pwfx.wFormatTag=1;
					pwfx.nChannels=2;
					pwfx.nSamplesPerSec=44100;//SAMPLERATE;
					pwfx.nAvgBytesPerSec=pwfx.nSamplesPerSec*4;
					pwfx.nBlockAlign=4;
					pwfx.wBitsPerSample=16;
					pwfx.cbSize=0;

					waveOutOpen(&shwd,WAVE_MAPPER,&pwfx,(unsigned long)hwndDlg,0,CALLBACK_WINDOW);
					pwhOut1.lpData=(char*)buffer1;
					pwhOut1.dwBufferLength=sizeof(buffer1);
					pwhOut1.dwFlags=0;
					pwhOut1.dwLoops=0;
		
					pwhOut2.lpData=(char*)buffer2;
					pwhOut2.dwBufferLength=sizeof(buffer2);
					pwhOut2.dwFlags=0;
					pwhOut2.dwLoops=0;
	
					waveOutPrepareHeader(shwd, &pwhOut1, sizeof(pwhOut1));
					waveOutPrepareHeader(shwd, &pwhOut2, sizeof(pwhOut2));
					
					waveOutWrite(shwd,&pwhOut1,sizeof(pwhOut1));
					waveOutWrite(shwd,&pwhOut2,sizeof(pwhOut2));
				}
			
			SetTimer(hwndDlg,33,20,NULL);
		}
		break;

		case WM_CLOSE:
			
			KillTimer(hwndDlg,33);

			waveOutReset(shwd);

			waveOutBreakLoop(shwd);
			waveOutBreakLoop(shwd);
  
			waveOutUnprepareHeader(shwd,&pwhOut1,sizeof WAVEHDR);
			waveOutUnprepareHeader(shwd,&pwhOut2,sizeof WAVEHDR);
			
			CLOSEMODSYS();

			waveOutClose(shwd);
			nbinstance=0;
			DestroyWindow(hwndDlg);
		break;
		
		case WM_TIMER:
		
			for(i=0;i<(180*86);i++) 
			{
				t=rand();
				buffer[i]=t&0xff;
			}

				
			fr++;
			
			putsprite((unsigned int)((float)cos(f1)*(float)35+(float)35),(unsigned int)((float)cos(f2)*(float)16+(float)16),(unsigned char*)buffer,111,54,(unsigned char*)logoeceb);
			
			f1=f1+(float)0.11;
			f2=f2+(float)0.09;
			
			hdc=GetDC(hwndDlg);
			GetClientRect(hwndDlg,&myRect);
			StretchDIBits(hdc,180,17,180,86,0,0,180,86,buffer,bmapinfo,0,SRCCOPY);
			ReleaseDC(hwndDlg,hdc);
		
		break;

		default:
		return false;
		
	}

	return true;
}

///////////////////////////////////////////About Demo//////////////////////////////////////


////////////////////////////////////////////////////////////////
//
//	Fonction de la boite de dialogue info fiche 
//	sert uniquement la gestion de l'evenement close ...
//
////////////////////////////////////////////////////////////////

BOOL CALLBACK DialogFicheProc(
    HWND  hwndDlg,	// handle of dialog box
    UINT  message,	// message
    WPARAM  wParam,	// first message parameter
    LPARAM  lParam 	// second message parameter
   )
{
	int wmId;//, wmEvent;
	wmId    = LOWORD(wParam);
	switch (message) 
	{


		case WM_COMMAND:
			switch (wmId)
			{
				case ID_OK:
					DestroyWindow(hwndDlg);
				default:;
			}

		break;
		
		case WM_CLOSE:
			DestroyWindow(hwndDlg);
		break;
	
		default:
		return false;
		
	}

	return true;
}


//////////////////////////////////////////////////////////////
//
// Fonction de comparaison pour trier dans la liste (vue)
// appelle automatiquement pour chaque lement de la liste ....
//
//////////////////////////////////////////////////////////////
int CALLBACK ListViewCompareProc(LPARAM lParam1, LPARAM lParam2,
                                 LPARAM lParamSort) 
{ 
    int iResult; 
    if (lParam1 && lParam2) 
    { 
	
        switch( lParamSort) 
        { 
            case 0:                  
				iResult = lstrcmpi((char*)lParam1,(char*)lParam2);
                break; 
            default: 
                iResult = 0; 
                break; 
        } 
 
    } 
    return(iResult); 
}



////////////////////////////////////////////////////////////////
//
//	Fonction Callback du timer permettant la gestion de la 
//	sauvegarde auto et de l'icone de la barre des tache
//
////////////////////////////////////////////////////////////////

VOID CALLBACK TimerProc1(HWND  hwnd,UINT  uMsg,UINT  idEvent,DWORD  dwTime)
{
	static HWND Dialog;
	tm *ntime;
	long now=0;
	bool retour;
	int i;
	laliste LaListe1=0;
	LaListe1=GetListe();
	retour=false;
	i=0;

	switch(idEvent)
	{
		case 0://timer 0 sauvegarde auto
			if(!SauvegardeListe(GetListe(),FICHIERFICHES))
			{
				KillTimer(hwnd,0);
				MessageBox(hwnd,"Can't save the data file !!!","Write Error !",MB_OK|MB_ICONHAND);

			}
		break;

		case 1://timer 1 verif fete temps reel...
			while(LaListe1!=0 && i!=2)
			{
				now = time(NULL);
				ntime=gmtime(&now);

				i=VerifierFete(LaListe1);
				
				if(i==2 || i==1) retour=true;					

				LaListe1=ElemSuivant(LaListe1);
			}
			
			// Modification de l'icone de la barre des taches en consquence
			if(i==2) //si anniversaire
			{
				if(ntime->tm_sec & 1) //seconde impaire (icone normale)
					AjouteModifieIcone(hwnd, 0, LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(500)),false);
				else				  //seconde paire   (icone anniversaire)
					AjouteModifieIcone(hwnd, 0, LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(502)),false);
			}
			else
			{
				if(retour==true) //si fte
				{
					if(ntime->tm_sec & 1)//seconde impaire (icone normale)
						AjouteModifieIcone(hwnd, 0, LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(500)),false);
					else				//seconde paire     (icone fte)
						AjouteModifieIcone(hwnd, 0, LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(501)),false);
				}
			}
			
			// si rien (icone normale)
			if(!retour)AjouteModifieIcone(hwnd, 0, LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(500)),false);
				break;
	}
}
  