/*-----------------------------------------------------------------------------------------*/
//					
//								Repertoire 2002	v1.0a
//																					
// File:  Repertoire2002Liste.cpp	
//																											
// Contains:	Fonctions de gestions de la liste et des fichiers et des ftes....	
//				(listes , sauvegardes , gestion dates,etc...)																	
//																										
// Written by:	DEL NERO Jean Francois																					
//				GUITTON  Rmy
//																					
// Copyright: Copyright  2002-2003 ECE
//   		  www.powerofasm.fr.st
//   																											
// Change History (most recent first):																				
//     																								
//  																											
/*-----------------------------------------------------------------------------------------*/

#include <windows.h>
#include <commctrl.h>
#include <shellapi.h>
#include <stdio.h>
#include <time.h>

#include "..\resource.h"

#include "..\includes\Repertoire2002Liste.h"
#include "..\includes\Repertoire2002I.h"
#include "..\includes\Repertoire2002.h"


/////////////////////////////////////////////////////////////////////////////////
//
//	Fonction permettant d'ajouter un nouvel lment dans la liste
//
//   Entree ->	laliste : La liste a laquelle on veux ajouter l'element.
//				unefiche : fiche  ajouter
//
//   Retour ->	la liste modifie
//				
//
/////////////////////////////////////////////////////////////////////////////////

laliste AjouterElement(typefiche unefiche,laliste Laliste)
{
	laliste nliste;
	
	nliste=(laliste) malloc(sizeof(elemliste));

	if(nliste!=NULL) //si le malloc ok
	{
		nliste->unefiche=(typefiche*)malloc(sizeof(typefiche));
		memcpy(nliste->unefiche,&unefiche,sizeof(typefiche));
		nliste->ElementSuivant=Laliste;
	}
	else 
	{
		nliste=Laliste;
	}
	return nliste;
}

/////////////////////////////////////////////////////////////////////////////////
//
//	Fonction permettant de savoir si la liste est vide
//
//   Entree ->	la liste 		
//
//   Retour ->	true : elle est vide 
//				false : elle n'est pas vide
//
/////////////////////////////////////////////////////////////////////////////////

bool EstVide(laliste Uneliste)
{
	return (Uneliste == NULL);
}

/////////////////////////////////////////////////////////////////////////////////
//
//	Fonction retournant l'element suivant de la liste
//
//   Entree ->	la liste 		
//
//   Retour ->	pointeur element suivant de la liste 
//				
/////////////////////////////////////////////////////////////////////////////////

laliste ElemSuivant(laliste Uneliste)
{
	return Uneliste->ElementSuivant;
}

/////////////////////////////////////////////////////////////////////////////////
//
//	Fonction permettant la suppression d'un element (identifi par nomprenom)
//
//   Entree ->	laliste : la liste a analyser
//				nomprenom : identificateur
//
//   Retour ->	la liste modifie (ou pas)
//				
/////////////////////////////////////////////////////////////////////////////////

laliste SupprimerFiche(laliste  laListe,char * nomprenom)
{
	laliste nliste;
	laliste nlisteo;
	laliste nlistet;
	char temp1[512];

	nliste=laListe;
	if(laListe!=NULL) // Il y a quelque chose dans la liste ?
	{
		// Cas si element a supprimer est le premier
	
		// reconstitution de l'identifier
		strcpy((char*)temp1,(char*)&nliste->unefiche->nom);
		strcat((char*)temp1,ESPACENOMPRENOM);
		strcat((char*)temp1,(char*)&nliste->unefiche->prenom);

		if(strcmp((char*)&temp1,nomprenom)==NULL) 
		{
			// si trouv on met l'element suivant en premier
			nliste=laListe->ElementSuivant;
			free(laListe->unefiche); // on libere la place de la fiche
			free(laListe);           // et celle de l'element de la liste
			nlisteo=nliste;          // element a retourner
		}
		else
		{
			nlisteo=nliste;

		// Cas si element a supprimer n'est pas le premier
		// ici on compare l'element suivant pour le supprimer directement
		// Suppression de l'element suivant :
		//
		//
		//						Element a supprimer
		//								|
		//								|
		//  --------------			-----------				-------------
		//	|Posi actuelle|------> |Elem suiv  |  --------> | Elem suiv 2 |
		//  --------------			-----------				--------------
		//		|													|
		//		|		Nouveau pointeur element suivant			|
		//		-----------------------------------------------------
		//

			do 
			{
	
				if(&nliste->ElementSuivant!=NULL)  //il ya t'il un element suivant ?
				{   
					// reconstitution de l'identifier
					strcpy((char*)temp1,(char*)&nliste->ElementSuivant->unefiche->nom);
					strcat((char*)temp1,ESPACENOMPRENOM);
					strcat((char*)temp1,(char*)&nliste->ElementSuivant->unefiche->prenom);
				}
	
				if(strcmp((char*)&temp1,nomprenom)==0) //si trouv
				{
					if(nliste->ElementSuivant->ElementSuivant!=NULL)
					{
						free(nliste->ElementSuivant->unefiche);// on libere la place de la fiche
						nlistet=nliste->ElementSuivant;
						//Le nouvel element suivant est "le suivant du suivant actuel"
						nliste->ElementSuivant=nliste->ElementSuivant->ElementSuivant;
						free(nlistet); // maintenant on peut liberer la place de l'element de la liste
						nliste=ElemSuivant(nliste); //on passe au suivant
					}
					else // si l element est le dernier de la liste
					{	
						free(nliste->ElementSuivant->unefiche);// on libere la place de la fiche
						free(nliste->ElementSuivant); // suppression de l'element de la liste
						nliste->ElementSuivant=NULL;
					}

				}
				else 
				{	//si pas bon element on passe au suivant
					if(&nliste->ElementSuivant!=NULL)
					nliste=ElemSuivant(nliste);
				}

			}while(nliste->ElementSuivant!=NULL); // on boucle tant qu'il y a un element a analyser...
		}
	}

return nlisteo;
}


/////////////////////////////////////////////////////////////////////////////////
//
//	Fonction permettant de modifier ou de recuperer la tete de liste
//
//   Entree ->	laliste : L'ventuelle nouvelle tte de liste
//				mode : true = set , false = get
//
//   Retour ->	la liste tete de liste (Get)
//				
//
/////////////////////////////////////////////////////////////////////////////////

laliste SetGetListe(laliste liste,bool mode)
{
	laliste retour;

	static laliste Laliste=NULL;
	
	if(mode) Laliste=liste;
	else retour=Laliste;
	
	return retour;
}

/////////////////////////////////////////////////////////////////////////////////
//
//	Fonction permettant de modifier la tete de liste
//
//   Entree ->	laliste : la nouvelle tte de liste
//
/////////////////////////////////////////////////////////////////////////////////

void SetListe(laliste Laliste)
{
	SetGetListe(Laliste,true);
}

/////////////////////////////////////////////////////////////////////////////////
//
//	Fonction permettant de recuperer la tete de liste
//
//   Retour ->	laliste : la tte de liste
//
/////////////////////////////////////////////////////////////////////////////////

laliste GetListe()
{
	return SetGetListe(NULL,false);
}

/////////////////////////////////////////////////////////////////////////////////
//
//	Fonction retournant une fiche recherche (identifie par nomprenom)
//
//   Entree ->	laliste : la liste a analyser
//				nomprenom : identificateur
//
//   Retour ->	la liste trouv ou passe en parametre
//				
/////////////////////////////////////////////////////////////////////////////////

laliste RechercherFiche(laliste  laListe,char * nomprenom)
{
	laliste nliste;

	char temp1[512];

	nliste=laListe;
	if(laListe!=NULL)
	{

		do	
		{
			strcpy((char*)temp1,(char*)&nliste->unefiche->nom);
			strcat((char*)temp1,ESPACENOMPRENOM);
			strcat((char*)temp1,(char*)&nliste->unefiche->prenom);

			if(strcmp(temp1,nomprenom)!=0)
			{
				nliste=ElemSuivant(nliste);
			}

		}
		while(strcmp(temp1,nomprenom)!=0 && nliste!=NULL);
	}

	return nliste;
}

////////////////////////////////////////////////////////////////////////// 
//
//   Fonction Permettant le filtrage de fiche (selon nom et prenom)
//
//   Entree ->	laliste : premier element  valuer
//				unefiche : fiche de filtrage
//
//   Retour ->	true si fiche passe  traver le filtre 
//				false si fiche bloque
//
//////////////////////////////////////////////////////////////////////////

bool FiltreFiche(laliste  laListe,typefiche unefiche)
{
	bool retour=true;

	if(strlen(unefiche.nom)!=0 && retour==true)
	{
		if(strnicmp(laListe->unefiche->nom,unefiche.nom,strlen(unefiche.nom))==0)  
			retour=true;
		else 
			retour=false;
	}	

	if(strlen(unefiche.prenom)!=0 && retour==true )
	{
		if(strnicmp(laListe->unefiche->prenom,unefiche.prenom,strlen(unefiche.prenom))==0) 
			retour=true;
		else retour=false;	
	}

return retour;
}


////////////////////////////////////////////////////////////////////////// 
//
//	Fonction permettant la recherche (selon nom et prenom) et la mise
//	 jours le la liste (vue) 	
//
//   Entree ->  laliste : premier element a elevaluer
//				unefiche : fiche de filtrage
//				liste : liste (vue) a mettre a jour
//   Retour ->	Pas de retour
//				
//
//////////////////////////////////////////////////////////////////////////

void RechercherFicheCritere(laliste  laListe,typefiche unefiche,HWND liste)
{

	laliste LaList1=laListe;

	// On efface le contenu de la vue
	ListView_DeleteAllItems(liste);

	while(LaList1!=NULL)
	{
		if(FiltreFiche(LaList1,unefiche))
		{	// Ajoute un element dans la liste (vue) avec la bonne icone (VerifierFete(..) )
			AjouteFicheListe(LaList1->unefiche,liste,VerifierFete(LaList1));
		}
		LaList1=ElemSuivant(LaList1);
	}
	
}

////////////////////////////////////////////////////////////////////////// 
//
//   Fonction permettant de savoir si la personne de la fiche a une fte.
//   Entree ->  laliste : premier element a elevaluer
//
//   Retour ->	0 pas de fete 
//				1 saint ...
//				2 anniversiare
//
//////////////////////////////////////////////////////////////////////////

int VerifierFete(laliste fiche1)
{
	int jour;
	int mois;
	tm *ntime;
	long now=0;
	int retour=0;

	// Recuperation de la date actuelle
	now = time(NULL);
	ntime=gmtime(&now);

	// Recherche de la fete de fiche1
	if(RechercheNomFete((char*)&fiche1->unefiche->prenom,&mois,&jour)==true)
	{		
		if(ntime->tm_mday==jour && ntime->tm_mon+1==mois)
		{	
			retour=1;
		}
	}
	
	// Verification de l'anniversaire
	if((fiche1->unefiche->datedenaissance.jour==(unsigned)(ntime->tm_mday)) && ((fiche1->unefiche->datedenaissance.mois)==(unsigned)(ntime->tm_mon+1)) && (fiche1->unefiche->datedenaissance.annee!=0)) 
		retour=2;


return retour; 		
}

////////////////////////////////////////////////////////////////////////// 
//
//   Fonction permettant la recuperation de la date d'une fete d'un prenom 
//	 a partir du fichier...
//   Entree ->  *nom : le nom a chercher
//   Retour ->	true : ok trouv
//				false : pas de fete
//				*moisp  : mois de la date
//				*jourp  : jour de la date	
//
//////////////////////////////////////////////////////////////////////////

bool RechercheNomFete(char * nom,int * moisp, int * jourp)
{
	
	FILE* leFichier;
	bool retour=false;
	long now=0;
	tm *ntime;
	char fete[100];
	int mois,jour,i=0;
	
	now = time(NULL);
	ntime=gmtime(&now);
	i=0;
	
	//Recherche dans le fichier de la fete de "* nom"
	leFichier = fopen("calfetes.txt", "r");
	if(leFichier!=NULL)
	{
		do 
		{
			fscanf(leFichier,"%d:%d:%s",&jour,&mois,&fete);
			i++;
			if(stricmp((char*)nom,(char*)&fete)==0)
			{
				*moisp=mois;
				*jourp=jour;
				retour=true;
			}
		}while(i<=533 && retour==false);
	
		fclose(leFichier);
	}
	return retour;
}

////////////////////////////////////////////////////////////////////////// 
//
//   Fonction permettant le chargement d'une fiche
//   Entree ->  laliste : buffer
//				lefichier : nom du fichier
//				numero :	position dans le fichier
//
//   Retour ->	laliste : nouveau pointeur
//
//////////////////////////////////////////////////////////////////////////

laliste  ChargeUneFiche(laliste laliste,char * lefichier,int numero)
{
	bool retour=false;
	FILE* leFichier;
	typefiche lafichetest;
	leFichier = fopen(lefichier, "rb");
	
	if(leFichier!=NULL)
	{	// Positionnement  la fiche "numero"
		if(fseek(leFichier,numero*sizeof(typefiche)+sizeof(FileHeader),SEEK_SET)==0)
		{
			if(fread(&lafichetest, sizeof(typefiche), 1, leFichier)==1)
			{	// Jout de la nouvelle fiche
				laliste = AjouterElement(lafichetest, laliste);
				retour=true;
			}
		}
	fclose(leFichier);
	}
   
	return laliste;
}

////////////////////////////////////////////////////////////////////////// 
//
//   Fonction permettant la sauvegarde d'une fiche
//   Entree ->  laliste : buffer
//				lefichier : nom du fichier
//				numero :	position dans le fichier
//
//   Retour ->	laliste : nouveau pointeur
//
//////////////////////////////////////////////////////////////////////////

bool  SauvegardeUneFiche(laliste unefiche,char * lefichier,int numero)
{
	bool retour=true;
	FILE* leFichier;
	
	leFichier = fopen(lefichier, "a+b");
	
	if(leFichier!=NULL && unefiche!=NULL)
	{
		fseek(leFichier,numero*sizeof(typefiche),SEEK_SET);
		fwrite(unefiche->unefiche, sizeof(typefiche), 1, leFichier);
		fclose(leFichier);
		retour=true;
	}
	else
	{
		if(unefiche!=NULL) retour=false;
		if(leFichier!=NULL) fclose(leFichier);
	}
   
	return retour;
}

////////////////////////////////////////////////////////////////////////// 
//
//   Fonction permettant la sauvegarde tous les elements fiche d'une liste
//
//   Entree ->  listet : la liste d'element fiche  sauvegarder
//				lefichier : nom du fichier
//
//   Retour ->	true : ok
//			->  false : problme de fichier !
//
//////////////////////////////////////////////////////////////////////////

bool SauvegardeListe(laliste listet,char * lefichier)
{
	FILE* leFichier;
	int i=0;
	FileHeader header;
	bool retour=true;

	strcpy((char*)header.Signature,(char*)"R2K2");
	header.version=1;
	header.nbfiche=0;
		
	//effacement du contenu de l'ancien fichier
	leFichier = fopen(lefichier, "w+b");
	if(leFichier==NULL)
	{
		retour=false;
	}
	else
	{
		fwrite(&header,sizeof(header),1,leFichier);
		fclose(leFichier);

		i=0;
		if(listet!=NULL)
		{
			do
			{
				retour=SauvegardeUneFiche(listet,lefichier,i);
				listet=ElemSuivant(listet);
				i++;
			}while(listet!=NULL && retour==true);
		}
	
	// Ecriture du header...
	leFichier = fopen(lefichier, "r+b");
	if(leFichier!=NULL)
	{    
		header.nbfiche=i;
		fseek(leFichier,0,SEEK_SET);
		fwrite(&header, sizeof(header), 1, leFichier);
		fclose(leFichier);
	}
	
	}
	return retour;
}

////////////////////////////////////////////////////////////////////////// 
//
//   Fonction permettant le chargement des elements fiches present dans un fichier
//
//   Entree ->  listet : pointeur liste servant comme base
//				lefichier : nom du fichier
//
//   Retour ->	laliste  : nouvelle liste
//	
//////////////////////////////////////////////////////////////////////////

laliste ChargerListe(laliste listet,char * lefichier)
{
	laliste listeChargement;
	listeChargement=listet;
	FileHeader header;
	FILE* leFichier;
	int i=0;

	leFichier = fopen(lefichier, "rb");
	if(leFichier!=NULL)
	{	
		fread(&header, sizeof(header), 1, leFichier);
		fclose(leFichier);
	}
	else
	{
		strcpy((char*)header.Signature,(char*)"R2K2");
		header.version=1;
	}

	if(strcmp((char*)header.Signature,(char*)"R2K2")==0)
	{
		do
		{
			listeChargement=listet;
			listet=ChargeUneFiche(listet,lefichier,i);
			i++;
		}
		while(listet!=listeChargement);
	}
	else
	{
			MessageBox(GetActiveWindow(),"Fichier r2k invalide !!","Load Error !",MB_OK|MB_ICONHAND);
	}
	return listet;
}